GNU bug report logs - #69443
[PATCH] gnu: Add guile-gsl.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Artyom Bologov <mail@HIDDEN>; Keywords: patch; Done: Sharlatan Hellseher <sharlatanus@HIDDEN>; Maintainer for guix-patches is guix-patches@HIDDEN.

Message received at 69443-done <at> debbugs.gnu.org:


Received: (at 69443-done) by debbugs.gnu.org; 4 Apr 2024 11:27:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 04 07:27:29 2024
Received: from localhost ([127.0.0.1]:60644 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1rsLFh-00006s-1p
	for submit <at> debbugs.gnu.org; Thu, 04 Apr 2024 07:27:29 -0400
Received: from mail-wm1-x32f.google.com ([2a00:1450:4864:20::32f]:42090)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <sharlatanus@HIDDEN>) id 1rsLFf-00006f-3K
 for 69443-done <at> debbugs.gnu.org; Thu, 04 Apr 2024 07:27:28 -0400
Received: by mail-wm1-x32f.google.com with SMTP id
 5b1f17b1804b1-4162b20d040so2628485e9.0
 for <69443-done <at> debbugs.gnu.org>; Thu, 04 Apr 2024 04:27:22 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20230601; t=1712230036; x=1712834836; darn=debbugs.gnu.org;
 h=mime-version:message-id:date:subject:to:from:from:to:cc:subject
 :date:message-id:reply-to;
 bh=mQiD6wdgcs5S0FE3GuHo7zncJIupystpLZ8NW/V1WmE=;
 b=aomJAmniwgwsFy250LuNuE+BOBB85QQ4HZd4u8t9EHgX5VtnqAC1tSMLCx26dHGJkg
 uPul9udLeLqgUE1jTBGsh+PDrKQy1ik8DIm4LJpe6Neohg9OHdF8I1F8PfC2ZJJ5d6h6
 Yell/tk5tswxAVJYIg+CA9+HtBkWHYxDF4BAtWBMnQt5bSNtX70Dr4E+/FPpyHwAGAF6
 nXzCqBTFA9cOVvwxf5IIH6/rJ087fekv3F9liV18gvC2t0gaEH/QgR07iNENwBLRMKB3
 cccbkE29inrDW72Px9y7wU/BirYZL6He3ouS1ObfVHGamrColkNJvvG/+pgMVCXH9Tla
 S7fA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20230601; t=1712230036; x=1712834836;
 h=mime-version:message-id:date:subject:to:from:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=mQiD6wdgcs5S0FE3GuHo7zncJIupystpLZ8NW/V1WmE=;
 b=lr8Ic9FunULJMBTxtOVOMcAgcMz3jeO6SMLaSfPGkeXUG2FooZmhX48e4xr8+/lcgk
 zeXpFp8b70aZjdcUi6n/cux9yzQWaqDJxBh1t81YxzJQyZNQSk97IMPhrSCdqVFj8tCa
 U6IGJrHOXkajzvevNCUGwPFc36WSwX/7FgplRqvpShekcByiKRePaphxib6zZVg7nbqU
 4cvfBsPplcQVKqxsc+e3DDoZHvuq5zL8cYnoHgUorYK2MdpPP6buZt9WfBuzcvJ5N3qf
 J/p2bdp57giC28RSZdVIlsiJctF7Dlm4WFNdblHoycJXCdosMqMae+1fTenhrxr7sCfA
 wMKQ==
X-Gm-Message-State: AOJu0YxLEtB3lAjBL73e5eXF3s3HKakRO6RbCPwX7qBu+OFxY2JU2dmP
 HOzl1b4MinxVaMsGk7EVBTxAv1nselPvp+dbJugjdnE8vgkGW8cuehB2rRCpauo=
X-Google-Smtp-Source: AGHT+IHeZ3Dt9u9P1O2ByR8xjeKq+J2FF0+ZnWsqx7Lx/wVKl5MVrOHIG9mVBI4xRa8WLmdI+IBK3g==
X-Received: by 2002:a05:600c:3b83:b0:415:66ac:615a with SMTP id
 n3-20020a05600c3b8300b0041566ac615amr2289150wms.2.1712230036068; 
 Thu, 04 Apr 2024 04:27:16 -0700 (PDT)
Received: from guxtil (cpc100856-bagu15-2-0-cust368.1-3.cable.virginm.net.
 [82.25.93.113]) by smtp.gmail.com with ESMTPSA id
 t10-20020a05600c198a00b004156afd6843sm2372922wmq.18.2024.04.04.04.27.15
 for <69443-done <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 04 Apr 2024 04:27:15 -0700 (PDT)
From: Sharlatan Hellseher <sharlatanus@HIDDEN>
To: 69443-done <at> debbugs.gnu.org
Subject: [PATCH] gnu: Add guile-gsl.
Date: Thu, 04 Apr 2024 12:27:14 +0100
Message-ID: <87il0x5pwt.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 69443-done
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain


Hi,

Patch applied based on <https://issues.guix.gnu.org/69820>.

Thanks,
Oleg

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEmEeB3micIcJkGAhndtcnv/Ys0rUFAmYOjpIACgkQdtcnv/Ys
0rUDuQ//bAZpvBbnRcFHUhrhTRtMioHhMBX224ckPk30TDqStnjI/SIggnzbZv51
V4/VorZ27KIQeMFKYBIMeyMtv2Pyi8X4nZPWdcXQcEcQBQCD6xyemggu3+FHCsEp
37lpy0atmURTdNl+r2YNdhffHi4HTnMaoCyQOcyWf5tRcbXSEpR1/HN4X5/65fjz
pf7TsJfD10p8HqWu318nHitH5v+rQkmjypOEnD3tQ1Nzkq1tpGpsTzCDHeplkF5l
+3Whoiy5zJsOrIhU4O1UA8KyFESKfE6VGGljoZUblViwJX3xXACNEohsJzUYszyB
BzpTwaQpRzi9LUML1VRqYMyGLUycHwOKphFUrE1R4coKk0/XGJlXLlwdR4hemHHU
lxblpKjQK6BmRcQYXEeNX8ryjk2l17KTalK+J6IhINl40+ontbkMeOCH84aG7o+x
jM5dEiO9zEleprb2nQOTFwd552o6LF83ojDM4M2M8uG+V4TIMAs2jduM00MOOdG0
RCd2kpdaxv2B+8S7q/GkFIgk7F33lVYLIQi7J4cKhSr1DCf29ISZxu+bQPkqAmWz
3bIg1CMySeP7ITwECujjzmgRm/5AK//wFqtOpgelKL2PY7w8jvdc+L8QG5HNpCI6
r8Ey12SAchVJZM/avyveLFiknCIlcfRZC7V7TidmUb+bnbMcSos=
=n/Le
-----END PGP SIGNATURE-----
--=-=-=--




Notification sent to Artyom Bologov <mail@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Sharlatan Hellseher <sharlatanus@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 69443 <at> debbugs.gnu.org:


Received: (at 69443) by debbugs.gnu.org; 8 Mar 2024 23:31:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Mar 08 18:31:59 2024
Received: from localhost ([127.0.0.1]:59958 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1rijh1-0005Vs-23
	for submit <at> debbugs.gnu.org; Fri, 08 Mar 2024 18:31:59 -0500
Received: from mail-lf1-f49.google.com ([209.85.167.49]:52442)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <poptsov.artyom@HIDDEN>) id 1rijgv-0005Va-W7
 for 69443 <at> debbugs.gnu.org; Fri, 08 Mar 2024 18:31:57 -0500
Received: by mail-lf1-f49.google.com with SMTP id
 2adb3069b0e04-51381021af1so1865547e87.0
 for <69443 <at> debbugs.gnu.org>; Fri, 08 Mar 2024 15:31:21 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20230601; t=1709940615; x=1710545415; darn=debbugs.gnu.org;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=KTFu6MZQPgRGhhghse7ElNjm+JBwDJBuK2IOpa16kBo=;
 b=XyNqfawpJtHwthZ/+47vp8oI2Q2kzGj7wiJIUB7iczo36MOdX40Bqyf0LoVbvVyp9J
 Vwe2UaxdYb+ooNAQ1vUTKNQeU4uNdmGGeoqZXS6WN/EPapq4w0TeCXhONc6xJ/7rVEXO
 SqUHGALEbqd+AIcEzbiso21a1f9eZBc2SbdD/Oy5g6YkJnHlsIX0pF6cOPuiid0Yt/51
 3ZYxs9cv85rHjTPbLR9RxToj2P+MyG1oc4gJS6Rp9iPQXHPSzZ+dMbojhgNkyeePc5iF
 OYU55pMNm+kELXSNN6ZTdPWrSoBjUvDf7c5FXGaUUYcfMSmH5+a6XE0Dwu7o71oVin34
 /DiA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20230601; t=1709940615; x=1710545415;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date:message-id
 :reply-to;
 bh=KTFu6MZQPgRGhhghse7ElNjm+JBwDJBuK2IOpa16kBo=;
 b=hL+mgfEKHm3Mar4O833qTVGmtCFv1pEveoc1gwRHLv7iasKXcJHsq/lACKA3odoZyv
 QEe5e5/Vd4CE7DCgjm3ge9O9KmEcAt2xNHlfKEW9z9I1l7uHhLB8WDIg5fGF5jhtd2Lr
 1sbb8aWDT1p1nP5ZUHaa5GNglsTnV0iHfXQ67y+S991skfpCHP6bucrwhNCBIJJb2+tq
 zLTRYkjW/h3eInPpns8iRJXgC4+sccC8s8ivnLqy1aPStgW98F7KfCb5edCBJvbq8JpJ
 AX0huY95Tzd3RRNE/evo0jaoouPVXiQ+bNbph7Z1SFNwAx7/UQcnYbO5IVvmqKuzUYzd
 KS7Q==
X-Gm-Message-State: AOJu0YwDrf/4XWRRxankIOW9AgWXOlRWnJklXCyOdWoKoF5wCJjxvJQf
 6CRQzyL24KlrSoOrlOrc1VHZN11RG1T5clcGla0oAfNMSTji40dOXGOpYbGU
X-Google-Smtp-Source: AGHT+IHhQBxNV3JCTExZBFcArctBYB0IZIbcfuUwhdqIfeHO7Fc97LexhlO8wi3m5sfiSQ6QT9oYxA==
X-Received: by 2002:a05:6512:48ca:b0:513:6917:ae8e with SMTP id
 er10-20020a05651248ca00b005136917ae8emr257435lfb.37.1709940614891; 
 Fri, 08 Mar 2024 15:30:14 -0800 (PST)
Received: from elephant.. ([5.164.220.172]) by smtp.gmail.com with ESMTPSA id
 h23-20020a056512055700b005131ec01b6dsm97992lfl.246.2024.03.08.15.30.14
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 08 Mar 2024 15:30:14 -0800 (PST)
From: "Artyom V. Poptsov" <poptsov.artyom@HIDDEN>
To: 69443 <at> debbugs.gnu.org
Subject: [PATCH] gnu: guile-gsl: Fix build.
Date: Sat,  9 Mar 2024 02:29:41 +0300
Message-ID: <04ce2de3be93a1a06345350f46b29b159c3ef6a3.1709940581.git.poptsov.artyom@HIDDEN>
X-Mailer: git-send-email 2.41.0
MIME-Version: 1.0
X-Debbugs-Cc: glv@HIDDEN, cox.katherine.e+guix@HIDDEN,
 me@HIDDEN, sharlatanus@HIDDEN, jgart@HIDDEN
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 69443
Cc: "Artyom V. Poptsov" <poptsov.artyom@HIDDEN>, mail@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* gnu/packages/guile-xyz.scm (guile-gsl): Fix build.

Change-Id: Iaf653f25fd2b972e575d9c2fd1607cd490cc17db
---
 gnu/packages/guile-xyz.scm | 86 ++++++++++++++++++++++++++++----------
 1 file changed, 65 insertions(+), 21 deletions(-)

diff --git a/gnu/packages/guile-xyz.scm b/gnu/packages/guile-xyz.scm
index 9ddcc626fe..1f9d1ecb3e 100644
--- a/gnu/packages/guile-xyz.scm
+++ b/gnu/packages/guile-xyz.scm
@@ -4522,31 +4522,75 @@ (define-public guile-gsl
     (package
       (name "guile-gsl")
       (version "0.0.1")
-      (source (origin
-                (method git-fetch)
-                (uri (git-reference
-                      (url "https://github.com/aartaka/guile-gsl")
-                      (commit commit)))
-                (file-name (git-file-name name version))
-                (sha256
-                 (base32
-                  "00dy33ibvfhzs5xp65g4g8d02wy4fiamjbp3pg87cghg41q4lwkr"))))
-      (build-system guile-build-system)
+      (source
+       (origin
+         (method git-fetch)
+         (uri (git-reference
+               (url "https://github.com/aartaka/guile-gsl")
+               (commit commit)))
+         (file-name (git-file-name name version))
+         (sha256
+          (base32 "00dy33ibvfhzs5xp65g4g8d02wy4fiamjbp3pg87cghg41q4lwkr"))))
+      (build-system gnu-build-system)
       (arguments
-       '(#:source-directory "modules"
-         #:phases
-         #~(modify-phases %standard-phases
-             (add-before 'build 'substitute-gsl-so
-               (lambda _
-                 (let ((gsl (string-append #$(this-package-input "lmdb")
-                                           "/lib/libgsl.so")))
-                   (substitute* "modules/gsl/core.scm"
-                     (("libgsl.so") gsl))))))))
+       (list
+        #:modules `(((guix build guile-build-system)
+                     #:select (target-guile-effective-version))
+                    ,@%gnu-build-system-modules)
+        #:imported-modules `((guix build guile-build-system)
+                             ,@%gnu-build-system-modules)
+        #:phases #~(modify-phases %standard-phases
+                     (add-before 'build 'substitute-gsl-so
+                       (lambda _
+                         (let ((gsl (string-append #$(this-package-input "gsl")
+                                                   "/lib/libgsl.so")))
+                           (substitute* "modules/gsl/core.scm"
+                             (("libgsl.so")
+                              gsl)))))
+                     (delete 'configure)
+                     (replace 'build
+                       (lambda* (#:key inputs #:allow-other-keys)
+                         (setenv "CC" "gcc")
+                         (setenv "GUILE_AUTO_COMPILE" "0")
+                         (invoke "make")
+                         (setenv "LD_LIBRARY_PATH" "./")
+                         (let* ((module-dir "modules")
+                                (prefix (string-length module-dir)))
+                           (for-each (lambda (file)
+                                       (let* ((base (string-drop (string-drop-right
+                                                                  file 4)
+                                                                 prefix))
+                                              (go (string-append "go" base
+                                                                 ".go")))
+                                         (invoke "guild"
+                                                 "compile"
+                                                 "-L"
+                                                 module-dir
+                                                 file
+                                                 "-o"
+                                                 go)))
+                                     (find-files module-dir "\\.scm$")))))
+                     (delete 'check) ;no tests
+                     (replace 'install
+                       (lambda* (#:key outputs #:allow-other-keys)
+                         (let* ((lib (string-append #$output "/lib"))
+                                (guile #$(this-package-input "guile"))
+                                (version (target-guile-effective-version guile))
+                                (scm (string-append "/share/guile/site/"
+                                                    version))
+                                (go (string-append "/lib/guile/" version
+                                                   "/site-ccache")))
+                           (install-file "libguilegslblas.so" lib)
+                           (copy-recursively "modules/"
+                                             (string-append #$output scm))
+                           (copy-recursively "go/"
+                                             (string-append #$output go))))))))
       (native-inputs (list guile-3.0))
       (inputs (list guile-3.0 gsl))
       (home-page "https://github.com/aartaka/guile-gsl")
-      (synopsis "Bindings for GNU Scientific library in Guile.")
-      (description "This package provides Guile Scheme wrapper for libgsl.so.
+      (synopsis "Bindings for GNU Scientific library in Guile")
+      (description
+       "This package provides Guile Scheme wrapper for @code{libgsl.so}.
 Only vector, matrix, and BLAS operations are covered for now.")
       (license license:gpl3+))))
 

base-commit: 38a00bc089205818a351c363a107b8ba5c99fd0d
-- 
2.41.0





Information forwarded to glv@HIDDEN, cox.katherine.e+guix@HIDDEN, me@HIDDEN, sharlatanus@HIDDEN, jgart@HIDDEN, guix-patches@HIDDEN:
bug#69443; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Feb 2024 23:40:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 27 18:40:11 2024
Received: from localhost ([127.0.0.1]:37405 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1rf73S-0002sP-K5
	for submit <at> debbugs.gnu.org; Tue, 27 Feb 2024 18:40:11 -0500
Received: from lists.gnu.org ([209.51.188.17]:46570)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1rf73L-0002r1-Ph
 for submit <at> debbugs.gnu.org; Tue, 27 Feb 2024 18:40:05 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <mail@HIDDEN>) id 1rf6Uz-0003we-39
 for guix-patches@HIDDEN; Tue, 27 Feb 2024 18:04:33 -0500
Received: from mta-12-4.privateemail.com ([198.54.127.107])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <mail@HIDDEN>) id 1rf6Ux-0002ZU-7I
 for guix-patches@HIDDEN; Tue, 27 Feb 2024 18:04:32 -0500
Received: from mta-12.privateemail.com (localhost [127.0.0.1])
 by mta-12.privateemail.com (Postfix) with ESMTP id 3A3ED18000B3
 for <guix-patches@HIDDEN>; Tue, 27 Feb 2024 18:04:23 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=simple/simple; d=aartaka.me; s=default;
 t=1709075063; bh=kFc4C33nPhyzaBrzCZ8hT1n971W+tz56SYnLldljThQ=;
 h=From:To:Subject:Date:From;
 b=dEEwtBcl/pP7UoxT9XHP9TWiTTh4OG6GUUvDH+t5+qghFr5X1umlACcKufH5zv0VW
 6EEL0KOYrIbrxO1L4RGOupftldYMvnl3pMlIPt0vG0m3YsLQE3VN2h1NzmKPYdlYty
 LBDobgLuyBlr6Ra/oUyzQ8Yh6vI7Hk/v0n51wY3sMxjg/y+Oc1FHmFtTXDIbxxAuPt
 CnkmhC+j7MxpCRZh4A6t4GpoHl8sJ2ikoZKswbqhSZ8V/bqF54UJdEkaSQxiWIgNKJ
 W3N6ZII6Lomkjj3TJw5rnk299HhZqypKGr4whlrz7Z883sjses/F8J+DtqQTT7NBMv
 FS09EVj17dRBg==
Received: from paranoidal (unknown [185.167.217.34])
 by mta-12.privateemail.com (Postfix) with ESMTPA
 for <guix-patches@HIDDEN>; Tue, 27 Feb 2024 18:04:22 -0500 (EST)
User-agent: mu4e 1.10.8; emacs 29.1
From: Artyom Bologov <mail@HIDDEN>
To: Guix patches <guix-patches@HIDDEN>
Subject: [PATCH] gnu: Add guile-gsl.
Date: Wed, 28 Feb 2024 02:56:12 +0400
Message-ID: <877ciptsq4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Virus-Scanned: ClamAV using ClamSMTP
Received-SPF: pass client-ip=198.54.127.107; envelope-from=mail@HIDDEN;
 helo=MTA-12-4.privateemail.com
X-Spam_score_int: 16
X-Spam_score: 1.6
X-Spam_bar: +
X-Spam_report: (1.6 / 5.0 requ) BAYES_00=-1.9, DKIM_INVALID=0.1,
 DKIM_SIGNED=0.1, RCVD_IN_DNSWL_NONE=-0.0001, RCVD_IN_MSPIKE_H2=-0.001,
 RCVD_IN_SBL_CSS=3.335, SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 2.2 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi y'all, This is both a patch submission and a call for help—I'm
    far out of my waters with this package and am not sure of the proper Guix-y
    way to build it. So the build sequence for Guile GSL is: (1) Compile a bundled
    libguilegslblas.so with a C compiler, using the GSL libraries from package
    inputs. (2) Put proper paths to the GSL libraries and libguileg [...] 
 
 Content analysis details:   (2.2 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
                             medium trust
                             [209.51.188.17 listed in list.dnswl.org]
  3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
                             [185.167.217.34 listed in zen.spamhaus.org]
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.2 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi y'all, This is both a patch submission and a call for help—I'm
    far out of my waters with this package and am not sure of the proper Guix-y
    way to build it. So the build sequence for Guile GSL is: (1) Compile a bundled
    libguilegslblas.so with a C compiler, using the GSL libraries from package
    inputs. (2) Put proper paths to the GSL libraries and libguileg [...] 
 
 Content analysis details:   (1.2 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
                             [185.167.217.34 listed in zen.spamhaus.org]
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
                             medium trust
                             [209.51.188.17 listed in list.dnswl.org]
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi y'all,

This is both a patch submission and a call for help=E2=80=94I'm far out of =
my
waters with this package and am not sure of the proper Guix-y way to
build it.

So the build sequence for Guile GSL is:
(1) Compile a bundled libguilegslblas.so with a C compiler, using the GSL
    libraries from package inputs.
(2) Put proper paths to the GSL libraries and libguilegslblas into the
    Scheme files.
(3) Compile Scheme files as per guile-build-system.

I've got (2) and (3) more or less working. The problem is: which build
system should I use and how do I synthesize GNU build system (makefile,
libguilegslblas.so, (1)) and Guile one?

You can find my draft (doesn't build and is not usable in general) patch
attached below. Any help appreciated!


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0001-gnu-Add-guile-gsl.patch
Content-Description: gnu: Add guile-gsl

From 5bd38a674fff008c189d1c39495d771354c945fb Mon Sep 17 00:00:00 2001
From: Artyom Bologov <mail@HIDDEN>
Date: Wed, 28 Feb 2024 02:54:31 +0400
Subject: [PATCH] gnu: Add guile-gsl.

* gnu/packages/guile-xyz.scm (guile-gsl): New variable.
---
 gnu/packages/guile-xyz.scm | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)

diff --git a/gnu/packages/guile-xyz.scm b/gnu/packages/guile-xyz.scm
index b34472d5bd..6b9492c4b7 100644
--- a/gnu/packages/guile-xyz.scm
+++ b/gnu/packages/guile-xyz.scm
@@ -4474,6 +4474,40 @@ (define-public guile-ffi-cblas
 function: raw, typed, and functional.")
       (license license:lgpl3+))))
 
+(define-public guile-gsl
+  (let ((commit "8540bcb6afa9be37153852255608d26d5a4df9dd")
+        (revision "0"))
+    (package
+      (name "guile-gsl")
+      (version "0.0.1")
+      (source (origin
+                (method git-fetch)
+                (uri (git-reference
+                      (url "https://github.com/aartaka/guile-gsl")
+                      (commit commit)))
+                (file-name (git-file-name name version))
+                (sha256
+                 (base32
+                  "00dy33ibvfhzs5xp65g4g8d02wy4fiamjbp3pg87cghg41q4lwkr"))))
+      (build-system guile-build-system)
+      (arguments
+       '(#:source-directory "modules"
+         #:phases
+         #~(modify-phases %standard-phases
+             (add-before 'build 'substitute-gsl-so
+               (lambda _
+                 (let ((gsl (string-append #$(this-package-input "lmdb")
+                                           "/lib/libgsl.so")))
+                   (substitute* "modules/gsl/core.scm"
+                     (("libgsl.so") gsl))))))))
+      (native-inputs (list guile-3.0))
+      (inputs (list guile-3.0 gsl))
+      (home-page "https://github.com/aartaka/guile-gsl")
+      (synopsis "Bindings for GNU Scientific library in Guile.")
+      (description "This package provides Guile Scheme wrapper for libgsl.so.
+Only vector, matrix, and BLAS operations are covered for now.")
+      (license license:gpl3+))))
+
 (define-public guile-ffi-fftw
   (let ((commit "294ad9e7491dcb40026d2fec9be2af05263be1c0")
         (revision "2"))
-- 
2.41.0


--=-=-=
Content-Type: text/plain


Thanks,
--
Artyom Bologov.

--=-=-=--




Acknowledgement sent to Artyom Bologov <mail@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#69443; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 4 Apr 2024 11:30:03 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.